/*
 * Augmented Reality For Maemo
 * Based on the code available at https://code.launchpad.net/~rojtberg/arinterface/ by pavel
 *
 * Author: Tassio Knop
 * www.impa.br/~tknop
 */


#pragma once

#include <QGLShaderProgram>
#include <QTime>
#include <QMatrix4x4>
#include "ObjReader.h"
#include "CanvasPlane.h"
#include <vector>

#define CUBE 0
#define TEXT 1
#define PLANE 2
#define OBJ 3
const int shadowMapSize = 512;

class Object {
public:
	void setup(ObjReader objFile);
	void render(QGLShaderProgram& sp);
	void cleanup();
	void setupCube(float x=0, float y=0 , float z=0);
	void setupText(float size = 10, float x=0, float y=0 , float z=0);
	void setupPlane(float x=0, float y=0 , float z=0, float w = 2, float h = 2);
    unsigned int depthTex;
		unsigned int depthTex2;
    unsigned int id;
    QTime matAge;
    bool alive;
    bool selected;
    QTime selectTime;
    QMatrix4x4 matMV;
    float angleY; // angle to rotate light in modelspace
    float angleX;
    float scale;
		GLuint  cubeTexId;
		int type;
		int nvert;
		QVector<int> letters;
		bool hasNormal;
	unsigned int vbo;
	vector<TexSlice> slices;
	vector<CanvasPlane> tags;
};
