/*
 * Augmented Reality For Maemo
 * Based on the code available at https://code.launchpad.net/~rojtberg/arinterface/ by pavel
 *
 * Author: Tassio Knop
 * www.impa.br/~tknop
 */


#ifdef NO_ES
	#include <GL/glew.h>
	#include <GL/gl.h>
#else
	#include <GLES2/gl2.h>
#endif

#include "ShadowQuad.h"

void ShadowQuad::setup() {
	const float size = 80;
	const float quad[] = {-size, 0,-size,  // Pos
						 0, 1, 0,  // Normal
						 0, 1,     // UV
						-size, 0, size,
						 0, 1, 0,
						 0, 0,
						 size, 0,-size,
						 0, 1, 0,
						 1, 1,
						 size, 0, size,
						 0, 1, 0,
						 1, 0};

    glGenBuffers(1, &vbo);
    glBindBuffer(GL_ARRAY_BUFFER, vbo);
    glBufferData(GL_ARRAY_BUFFER, 8*4*sizeof(float), quad, GL_STATIC_DRAW);
    glBindBuffer(GL_ARRAY_BUFFER, 0); // unbind
}

void ShadowQuad::render(QGLShaderProgram& sp) {
    glBindBuffer(GL_ARRAY_BUFFER, vbo);

    sp.enableAttributeArray("vertex");
    sp.setAttributeArray("vertex", 0, 3, 8*sizeof(float));

		sp.enableAttributeArray("norm");
		sp.setAttributeArray("norm", (float*) (3 * sizeof(float)), 3, 8*sizeof(float));

		sp.enableAttributeArray("tex");
		sp.setAttributeArray("tex", (float*) (6 * sizeof(float)), 2, 8*sizeof(float));

    glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);

    glBindBuffer(GL_ARRAY_BUFFER, 0); // unbind
}

void ShadowQuad::cleanup() {
    glDeleteBuffers(1, &vbo);
}
