/*
 * Augmented Reality For Maemo
 * Based on the code available at https://code.launchpad.net/~rojtberg/arinterface/ by pavel
 *
 * Author: Tassio Knop
 * www.impa.br/~tknop
 */


#pragma once

#include "Scene.h"

#ifdef NO_ES
	#include <GL/glew.h>
#endif

#include <QGLWidget>
#include <QTime>

/**
 * View for Managing Input & Output
 */
class View : public QGLWidget {
public:
    View(Scene& s, QWidget* p);
    void start();
    Scene& s;
protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void keyPressEvent(QKeyEvent* event);
    bool event(QEvent *event);
    void mousePressEvent(QMouseEvent* event);
    void mouseMoveEvent(QMouseEvent* event);		
		QVector<QImage> imgs;
		QTime time;
		int frameCnt;
		QGLShaderProgram program1;
		QGLShaderProgram program2;
		GLuint  m_uiTexture, cubedepthtex;
		qreal   m_fAngle;
		qreal   m_fScale;
};


